]> git.ipfire.org Git - ipfire-2.x.git/blob - make.sh
Clamav- und MySQL-Paket gefixt.
[ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.0rc1t" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which versions should be compiled? (full|devel)
37
38 # Set an information about the build number
39 if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41 fi
42
43 # Debian specific settings
44 if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46 else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53 fi
54
55 PWD=`pwd`
56 BASENAME=`basename $0`
57 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58 LOGFILE=$BASEDIR/log/_build.preparation.log
59 export BASEDIR LOGFILE
60 DIR_CHK=$BASEDIR/cache/check
61 mkdir $BASEDIR/log/ 2>/dev/null
62
63 # Include funtions
64 . tools/make-functions
65
66 if [ -f .config ]; then
67 . .config
68 else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76 fi
77
78 prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j6"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213 }
214
215 buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253 }
254
255 buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
291 lfsmake2 gzip
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
296 lfsmake2 libaal
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 mtd
302 lfsmake2 net-tools
303 lfsmake2 patch
304 lfsmake2 psmisc
305 lfsmake2 reiser4progs
306 lfsmake2 shadow
307 lfsmake2 sysklogd
308 lfsmake2 sysvinit
309 lfsmake2 tar
310 lfsmake2 texinfo
311 lfsmake2 udev
312 lfsmake2 util-linux
313 lfsmake2 vim
314 lfsmake2 grub
315 }
316
317 buildipfire() {
318 LOGFILE="$BASEDIR/log/_build.ipfire.log"
319 export LOGFILE
320 ipfiremake configroot
321 ipfiremake dhcp
322 ipfiremake dhcpcd
323 ipfiremake libusb
324 ipfiremake libpcap
325 ipfiremake ppp
326 ipfiremake rp-pppoe
327 ipfiremake unzip
328 ipfiremake linux SMP=1
329 ipfiremake ipp2p SMP=1
330 ipfiremake r8169 SMP=1
331 ipfiremake zaptel SMP=1
332 ipfiremake linux
333 ipfiremake ipp2p
334 ipfiremake r8169
335 ipfiremake zaptel
336 ipfiremake pkg-config
337 ipfiremake cpio
338 ipfiremake klibc
339 ipfiremake mkinitcpio
340 ipfiremake udev KLIBC=1
341 ipfiremake expat
342 ipfiremake gdbm
343 ipfiremake gmp
344 ipfiremake pam
345 ipfiremake openssl
346 ipfiremake curl
347 ipfiremake python
348 ipfiremake libnet
349 ipfiremake libidn
350 ipfiremake libjpeg
351 ipfiremake libpng
352 ipfiremake libtiff
353 ipfiremake libart
354 ipfiremake freetype
355 ipfiremake gd
356 ipfiremake popt
357 ipfiremake pcre
358 ipfiremake slang
359 ipfiremake newt
360 ipfiremake libcap
361 ipfiremake pciutils
362 ipfiremake usbutils
363 ipfiremake libxml2
364 ipfiremake libxslt
365 ipfiremake BerkeleyDB
366 ipfiremake mysql
367 ipfiremake cyrus-sasl
368 ipfiremake openldap
369 ipfiremake apache2
370 ipfiremake php
371 ipfiremake apache2 PASS=C
372 ipfiremake arping
373 ipfiremake beep
374 ipfiremake bind
375 ipfiremake cdrtools
376 ipfiremake dnsmasq
377 ipfiremake dosfstools
378 ipfiremake squashfstools
379 ipfiremake reiserfsprogs
380 ipfiremake sysfsutils
381 ipfiremake fuse
382 ipfiremake ntfs-3g
383 ipfiremake ethtool
384 ipfiremake ez-ipupdate
385 ipfiremake fcron
386 ipfiremake perl-GD
387 ipfiremake GD-Graph
388 ipfiremake GD-TextUtil
389 ipfiremake gnupg
390 ipfiremake hdparm
391 ipfiremake sdparm
392 ipfiremake mtools
393 ipfiremake initscripts
394 ipfiremake whatmask
395 ipfiremake iptables
396 ipfiremake libupnp
397 ipfiremake ipp2p IPT=1
398 ipfiremake moblock
399 ipfiremake linux-igd
400 ipfiremake ipac-ng
401 ipfiremake ipaddr
402 ipfiremake iptstate
403 ipfiremake iputils
404 ipfiremake l7-protocols
405 ipfiremake mISDN
406 ipfiremake hwdata
407 ipfiremake kudzu
408 ipfiremake logrotate
409 ipfiremake logwatch
410 ipfiremake misc-progs
411 ipfiremake nano
412 ipfiremake nasm
413 ipfiremake URI
414 ipfiremake HTML-Tagset
415 ipfiremake HTML-Parser
416 ipfiremake Compress-Zlib
417 ipfiremake Digest
418 ipfiremake Digest-SHA1
419 ipfiremake Digest-HMAC
420 ipfiremake libwww-perl
421 ipfiremake Net-DNS
422 ipfiremake Net-IPv4Addr
423 ipfiremake Net_SSLeay
424 ipfiremake IO-Stringy
425 ipfiremake Unix-Syslog
426 ipfiremake Mail-Tools
427 ipfiremake MIME-Tools
428 ipfiremake Net-Server
429 ipfiremake Convert-TNEF
430 ipfiremake Convert-UUlib
431 ipfiremake Archive-Tar
432 ipfiremake Archive-Zip
433 ipfiremake Text-Tabs+Wrap
434 ipfiremake Locale-Country
435 ipfiremake XML-Parser
436 ipfiremake glib
437 ipfiremake GeoIP
438 ipfiremake fwhits
439 ipfiremake noip_updater
440 ipfiremake ntp
441 ipfiremake openssh
442 ipfiremake openswan
443 ipfiremake rrdtool
444 ipfiremake setserial
445 ipfiremake setup
446 ipfiremake snort
447 ipfiremake oinkmaster
448 ipfiremake squid
449 ipfiremake squid-graph
450 ipfiremake squidguard
451 ipfiremake calamaris
452 ipfiremake tcpdump
453 ipfiremake traceroute
454 ipfiremake vlan
455 ipfiremake wireless
456 ipfiremake libsafe
457 ipfiremake pakfire
458 ipfiremake java
459 ipfiremake spandsp
460 ipfiremake lzo
461 ipfiremake openvpn
462 ipfiremake pammysql
463 ipfiremake cups
464 ipfiremake ghostscript
465 ipfiremake foomatic
466 ipfiremake samba
467 ipfiremake sudo
468 ipfiremake mc
469 ipfiremake wget
470 ipfiremake bridge-utils
471 ipfiremake screen
472 ipfiremake hddtemp
473 ipfiremake smartmontools
474 ipfiremake htop
475 ipfiremake postfix
476 ipfiremake fetchmail
477 ipfiremake cyrusimap
478 ipfiremake openmailadmin
479 ipfiremake mailx
480 ipfiremake clamav
481 ipfiremake spamassassin
482 ipfiremake amavisd
483 ipfiremake alsa
484 ipfiremake mpg123
485 ipfiremake mpfire
486 ipfiremake guardian
487 ipfiremake libid3tag
488 ipfiremake libmad
489 ipfiremake libogg
490 ipfiremake libvorbis
491 ipfiremake lame
492 ipfiremake sox
493 ipfiremake libshout
494 ipfiremake icecast
495 ipfiremake icegenerator
496 ipfiremake mpd
497 ipfiremake mpc
498 ipfiremake xvid
499 ipfiremake libmpeg2
500 #ipfiremake ffmpeg
501 ipfiremake videolan
502 ipfiremake libpri
503 ipfiremake stund
504 ipfiremake asterisk
505 ipfiremake backup
506 ipfiremake gnump3d
507 ipfiremake libsigc++
508 ipfiremake applejuice
509 ipfiremake ocaml
510 ipfiremake mldonkey
511 ipfiremake libtorrent
512 ipfiremake rtorrent
513 ipfiremake ipfireseeder
514 ipfiremake rsync
515 ipfiremake tcpwrapper
516 ipfiremake portmap
517 ipfiremake nfs
518 ipfiremake nmap
519 ipfiremake mbmon
520 ipfiremake iftop
521 ipfiremake ncftp
522 ipfiremake cftp
523 ipfiremake etherwake
524 ipfiremake ethereal
525 ipfiremake tftp-hpa
526 ipfiremake bwm-ng
527 ipfiremake tripwire
528 ipfiremake sysstat
529 ipfiremake vsftpd
530 ipfiremake which
531 ipfiremake lsof
532 }
533
534 buildinstaller() {
535 # Run installer scripts one by one
536 LOGFILE="$BASEDIR/log/_build.installer.log"
537 export LOGFILE
538 ipfiremake syslinux
539 ipfiremake as86
540 ipfiremake mbr
541 ipfiremake memtest
542 installmake linux-libc-header
543 installmake binutils
544 ipfiremake uClibc PASS=1
545 ipfiremake gcc INST=1
546 installmake uClibc PASS=2
547 installmake gcc INST=2
548 installmake uClibc PASS=3
549 installmake busybox
550 installmake udev
551 installmake slang
552 installmake newt
553 installmake gettext
554 installmake kbd
555 installmake popt
556 installmake sysvinit
557 installmake misc-progs
558 installmake libaal
559 installmake reiser4progs
560 installmake reiserfsprogs
561 installmake sysfsutils
562 installmake util-linux
563 installmake pciutils
564 installmake zlib
565 installmake mtd
566 installmake wget
567 installmake hwdata
568 installmake kudzu
569 installmake installer
570 installmake initrd
571 }
572
573 buildpackages() {
574 LOGFILE="$BASEDIR/log/_build.packages.log"
575 export LOGFILE
576 echo "... see detailed log in _build.*.log files" >> $LOGFILE
577
578 installmake strip
579
580 # Generating list of packages used
581 echo -n "Generating packages list from logs" | tee -a $LOGFILE
582 rm -f $BASEDIR/doc/packages-list
583 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
584 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
585 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
586 fi
587 done
588 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
589 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
590 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
591 rm -f $BASEDIR/doc/packages-list
592 # packages-list.txt is ready to be displayed for wiki page
593 beautify message DONE
594
595 # Create images for install
596 ipfiremake cdrom ED=full
597
598 # Check if there is a loop device for building in virtual environments
599 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
600 ipfiremake usb-stick
601 fi
602 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
603
604 ipfirepackages
605
606 # Cleanup
607 stdumount
608 rm -rf $BASEDIR/build/tmp/*
609
610 # Generating total list of files
611 echo -n "Generating files list from logs" | tee -a $LOGFILE
612 rm -f $BASEDIR/log/FILES
613 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
614 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
615 echo "##" >>$BASEDIR/log/FILES
616 echo "## `basename $i`" >>$BASEDIR/log/FILES
617 echo "##" >>$BASEDIR/log/FILES
618 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
619 fi
620 done
621 beautify message DONE
622
623 cd $PWD
624 }
625
626 ipfirepackages() {
627 ipfiremake core-updates
628 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
629 if [ -e $BASEDIR/lfs/$i ]; then
630 ipfiredist $i
631 else
632 echo -n $i
633 beautify message SKIP
634 fi
635 done
636 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
637 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
638 rm -rf $BASEDIR/build/install/packages/*
639 }
640
641 # See what we're supposed to do
642 case "$1" in
643 build)
644 clear
645 BUILDMACHINE=`uname -m`
646 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
647 #only restore on a clean disk
648 if [ ! -f log/cleanup-toolchain-2-tools ]; then
649 if [ ! -n "$PACKAGE" ]; then
650 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
651 prepareenv
652 buildtoolchain
653 else
654 PACKAGENAME=${PACKAGE%.tar.gz}
655 beautify build_stage "Packaged toolchain compilation"
656 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
657 tar zxf $PACKAGE
658 prepareenv
659 else
660 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
661 fi
662 fi
663 else
664 echo -n "Using installed toolchain" | tee -a $LOGFILE
665 beautify message SKIP
666 prepareenv
667 fi
668
669 beautify build_start
670 beautify build_stage "Building LFS"
671 buildbase
672
673 beautify build_stage "Building IPFire"
674 buildipfire
675
676 # Setzen des IPFire Builds
677 if [ "$FIREBUILD" ]; then
678 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
679 else
680 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
681 fi
682
683 beautify build_stage "Building installer"
684 buildinstaller
685
686 beautify build_stage "Building packages"
687 buildpackages
688 beautify build_end
689 ;;
690 shell)
691 # enter a shell inside LFS chroot
692 # may be used to changed kernel settings
693 prepareenv
694 entershell
695 ;;
696 changelog)
697 echo -n "Loading new Changelog from SVN: "
698 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
699 beautify message DONE
700 ;;
701 clean)
702 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
703 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
704 $LOSETUP -d $i 2>/dev/null
705 done
706 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
707 umount $i
708 done
709 stdumount
710 for i in `seq 0 7`; do
711 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
712 umount /dev/loop${i} 2>/dev/null;
713 losetup -d /dev/loop${i} 2>/dev/null;
714 fi;
715 done
716 rm -rf $BASEDIR/build
717 rm -rf $BASEDIR/cdrom
718 rm -rf $BASEDIR/packages
719 rm -rf $BASEDIR/log
720 if [ -h /tools ]; then
721 rm -f /tools
722 fi
723 beautify message DONE
724 ;;
725 downloadsrc)
726 if [ ! -d $BASEDIR/cache ]; then
727 mkdir $BASEDIR/cache
728 fi
729 mkdir -p $BASEDIR/log
730 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
731 FINISHED=0
732 cd $BASEDIR/lfs
733 for c in `seq $MAX_RETRIES`; do
734 if (( FINISHED==1 )); then
735 break
736 fi
737 FINISHED=1
738 cd $BASEDIR/lfs
739 for i in *; do
740 if [ -f "$i" -a "$i" != "Config" ]; then
741 echo -ne "Loading $i"
742 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
743 if [ $? -ne 0 ]; then
744 beautify message FAIL
745 FINISHED=0
746 else
747 if [ $c -eq 1 ]; then
748 beautify message DONE
749 fi
750 fi
751 fi
752 done
753 done
754 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
755 ERROR=0
756 for i in *; do
757 if [ -f "$i" -a "$i" != "Config" ]; then
758 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
759 if [ $? -ne 0 ]; then
760 echo -ne "MD5 difference in lfs/$i"
761 beautify message FAIL
762 ERROR=1
763 fi
764 fi
765 done
766 if [ $ERROR -eq 0 ]; then
767 echo -ne "${BOLD}all files md5sum match${NORMAL}"
768 beautify message DONE
769 else
770 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
771 beautify message FAIL
772 fi
773 cd - >/dev/null 2>&1
774 ;;
775 toolchain)
776 clear
777 prepareenv
778 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
779 buildtoolchain
780 BUILDMACHINE=`uname -m`
781 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
782 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
783 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
784 build/{bin,etc,usr/bin,usr/local} \
785 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
786 log >> $LOGFILE
787 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
788 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
789 stdumount
790 ;;
791 gettoolchain)
792 BUILDMACHINE=`uname -m`
793 # arbitrary name to be updated in case of new toolchain package upload
794 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
795 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
796 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
797 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
798 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
799 cd $BASEDIR/cache/toolchains
800 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
801 if [ $? -ne 0 ]; then
802 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
803 else
804 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
805 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
806 else
807 exiterror "$PACKAGE.md5 did not match, check downloaded package"
808 fi
809 fi
810 else
811 echo "Toolchain is already downloaded. Exiting..."
812 fi
813 ;;
814 othersrc)
815 prepareenv
816 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
817 chroot $LFS /tools/bin/env -i HOME=/root \
818 TERM=$TERM PS1='\u:\w\$ ' \
819 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
820 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
821 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
822 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
823 if [ $? -eq "0" ]; then
824 beautify message DONE
825 else
826 beautify message FAIL
827 fi
828 stdumount
829 ;;
830 svn)
831 case "$2" in
832 update|up)
833 # clear
834 echo -ne "Loading the latest source files...\n"
835 if [ $3 ]; then
836 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
837 else
838 svn update | tee -a $PWD/log/_build.svn.update.log
839 fi
840 if [ $? -eq "0" ]; then
841 beautify message DONE
842 else
843 beautify message FAIL
844 exit 1
845 fi
846 echo -ne "Writing the svn-info to a file"
847 svn info > $PWD/svn_status
848 if [ $? -eq "0" ]; then
849 beautify message DONE
850 else
851 beautify message FAIL
852 exit 1
853 fi
854 chmod 755 $0
855 exit 0
856 ;;
857 commit|ci)
858 clear
859 if [ -f /usr/bin/mcedit ]; then
860 export EDITOR=/usr/bin/mcedit
861 fi
862 if [ -f /usr/bin/nano ]; then
863 export EDITOR=/usr/bin/nano
864 fi
865 echo -ne "Selecting editor $EDITOR..."
866 beautify message DONE
867 if [ -e /sbin/yast ]; then
868 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
869 $0 changelog
870 fi
871 fi
872 update_langs
873 svn commit
874 $0 svn up
875 if [ -n "$FTP_CACHE_URL" ]; then
876 $0 uploadsrc
877 fi
878 ;;
879 dist)
880 if [ $3 ]; then
881 SVN_REVISION=$3
882 fi
883 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
884 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
885 exit 0
886 fi
887 echo -en "REV $SVN_REVISION: Downloading..."
888 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
889 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
890 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
891 evaluate 1
892
893 echo -en "REV $SVN_REVISION: Compressing files..."
894 if [ -e ipfire-source/trunk/make.sh ]; then
895 chmod 755 ipfire-source/trunk/make.sh
896 fi
897 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
898 evaluate 1
899 echo -en "REV $SVN_REVISION: Cleaning up..."
900 rm ipfire-source/ -r
901 evaluate 1
902 ;;
903 diff|di)
904 update_langs
905 echo -ne "Make a local diff to last svn revision"
906 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
907 evaluate 1
908 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
909 svn status
910 ;;
911 esac
912 ;;
913 uploadsrc)
914 PWD=`pwd`
915 cd $BASEDIR/cache/
916 echo -e "Uploading cache to ftp server:"
917 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL/$FTP_CACHE_PATH/ > /tmp/ftplist
918 for i in *; do
919 if [ "$(basename $i)" == "toolchains" ]; then continue; fi
920 grep -q $(basename $i) /tmp/ftplist
921 if [ "$?" -ne "0" ]; then
922 echo -ne "$(basename $i)"
923 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $(basename $i)
924 if [ "$?" -ne "0" ]; then
925 beautify message FAIL
926 fi
927 fi
928 done
929 rm -f /tmp/ftplist
930 cd $PWD
931 exit 0
932 ;;
933 upload)
934 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
935 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
936 if [ -z $FTP_ISO_PORT ]; then
937 FTP_ISO_PORT=21
938 fi
939 cat <<EOF > .ftp-commands
940 mkdir -p $FTP_ISO_PATH$SVN_REVISION
941 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
942 quit
943 EOF
944 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
945 rm -f .ftp-commands
946
947 case "$2" in
948 iso)
949 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
950
951 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
952 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
953 if [ -e "$i" ]; then
954 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
955 if [ "$?" -eq "0" ]; then
956 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
957 else
958 echo "There was an error while uploading the file $i to the ftp server."
959 exit 1
960 fi
961 fi
962 done
963 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
964 if [ "$3" = "--with-sources-cd" ]; then
965 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
966 fi
967 ;;
968 paks)
969 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
970 if [ "$?" -eq "0" ]; then
971 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
972 else
973 echo -e "There was an error while uploading the packages to the ftp server."
974 exit 1
975 fi
976 ;;
977 esac
978 ;;
979 batch)
980 if [ "$2" = "--background" ]; then
981 batch_script
982 exit $?
983 fi
984 if [ `screen -ls | grep -q ipfire` ]; then
985 echo "Build is already running, sorry!"
986 exit 1
987 else
988 if [ "$2" = "--rebuild" ]; then
989 export IPFIRE_REBUILD=1
990 echo "REBUILD!"
991 else
992 export IPFIRE_REBUILD=0
993 fi
994 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
995 screen -dmS ipfire $0 batch --background
996 evaluate 1
997 exit 0
998 fi
999 ;;
1000 watch)
1001 watch_screen
1002 ;;
1003 pxe)
1004 case "$2" in
1005 start)
1006 start_tftpd
1007 ;;
1008 stop)
1009 stop_tftpd
1010 ;;
1011 reload|restart)
1012 reload_tftpd
1013 ;;
1014 esac
1015 exit 0
1016 ;;
1017 lang)
1018 update_langs
1019 ;;
1020 "")
1021 clear
1022 svn info
1023 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1024 do
1025 case $name in
1026 "IPFIRE: Downloadsrc")
1027 $0 downloadsrc
1028 ;;
1029 "IPFIRE: Build (silent)")
1030 $0 build-silent
1031 ;;
1032 "IPFIRE: Watch Build")
1033 $0 watch
1034 ;;
1035 "IPFIRE: Batch")
1036 $0 batch
1037 ;;
1038 "IPFIRE: Clean")
1039 $0 clean
1040 ;;
1041 "SVN: Update")
1042 $0 svn update
1043 ;;
1044 "Help")
1045 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1046 cat doc/make.sh-usage
1047 ;;
1048 "LOG: Tail")
1049 tail -f log/_*
1050 ;;
1051 "Exit")
1052 break
1053 ;;
1054 esac
1055 done
1056 ;;
1057 config)
1058 make_config
1059 ;;
1060 *)
1061 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1062 cat doc/make.sh-usage
1063 ;;
1064 esac